#ifndef _EX_Bus_H
#define _EX_Bus_H

#include "Prefix.h"
#include "EARTH_PT3.h"
#include "EX_Device.h"
#include "EX_Utility.h"

namespace EARTH {
namespace EX {
	class Bus {
	public:
		Bus()
		{
			mBus = NULL;
		}

		~Bus()
		{
			if (mBus) {
				status	status = mBus->Delete();
				if (U::Error(L"Bus::Delete()", status)) return;
				mBus = NULL;
			}
		}

		void Run(PT::Bus::NewBusFunction function)
		{
			_ASSERT(mBus == NULL);
			status	status = function(&mBus);
			if (U::Error(L"Bus::Run()", status)) return;
			_ASSERT(mBus);

			uint32	version;
			mBus->GetVersion(&version);
			if ((version >> 8) != 2) {
				::wprintf(L"CXg[Ă SDK ̃o[W(0x%08x) ɂ͑ΉĂ܂B\n", version);
				return;
			}

			// ̃Tvł U::GetNumber() ŃfoCXI΂ȂƂȂ߁AfoCX̏ 9 ɂĂ܂B
			PT::Bus::DeviceInfo		deviceInfo[9];
			uint32	deviceInfoCount = sizeof(deviceInfo)/sizeof(*deviceInfo);
			mBus->Scan(deviceInfo, &deviceInfoCount);

			bool	done = false;
			while (done == false) {
				::wprintf(L"[foCXIj[]\n");
				::wprintf(L"   Bus:oXԍ / Dev:foCXԍ / Fun:t@NVԍ / PTn:i\n");
				::wprintf(L"--+---+---+---+---\n");
				::wprintf(L"#  Bus Dev Fun PTn\n");
				::wprintf(L"--+---+---+---+---\n");

				::wprintf(L"0: (I)\n");
				for (uint32 i=0; i<deviceInfoCount; i++) {
					const PT::Bus::DeviceInfo	*info = &deviceInfo[i];
					::wprintf(L"%d: %3d %3d %3d %3d\n",
						i+1, info->Bus, info->Slot, info->Function, info->PTn);
				}

				::wprintf(L">");
				uint32	number = U::GetNumber(deviceInfoCount);
				if (number == 0) {
					done = true;
				} else {
					EX::Device	*device = new EX::Device();
					device->Run(mBus, &deviceInfo[number-1]);
					delete_(device);
				}
			}
		}

	protected:
		PT::Bus		*mBus;
	};
}
}

#endif
