#ifndef _EX_Errata_H
#define _EX_Errata_H

#include "Prefix.h"
#include "EARTH_PT3.h"
#include "EX_Stream.h"
#include "EX_Utility.h"
#include "OS_Thread.h"

namespace EARTH {
namespace EX {
	class Errata {
	public:
		Errata(PT::Device *device) : mDevice(device)
		{
			for (uint32 i=0; i<sizeof(mBuffer)/sizeof(*mBuffer); i++) {
				mBuffer[i] = NULL;
			}
		}

		~Errata()
		{
			for (uint32 i=0; i<sizeof(mBuffer)/sizeof(*mBuffer); i++) {
				delete_(mBuffer[i]);
			}
		}

		status Check()
		{
			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					status	status;
					bool	enabled;
					status = mDevice->GetTransferEnabled(isdb, j, &enabled);
					if (U::Error(L"GetTransferEnabled()", status)) return status;
					if (enabled) {
						::wprintf(L"SĂ DMA ~ԂłȂ߁Asł܂B\n");
						return 1;
					}
				}
			}

			::wprintf(L"s񐔂͂ĂB\n");
			::wprintf(L">");

			uint32	count;
			::wscanf_s(L"%4d", &count);

			status	status = EARTH::PT::STATUS_OK;
			
			for (uint32 i=0; i<count; i++) {
				status = TestHardware();
				if (status) break;
				::wprintf(L"%d ڂ̎s͐ɏI܂B\n", i+1);
			}

			StopTransfer();

			if (status) return status;

			::wprintf(L"SĂ̎s͐ɏI܂B\n");

			return status;
		}

	protected:
		PT::Device *const	mDevice;
		Buffer				*mBuffer[2*2];

		status TestHardware()
		{
			status	status;

			status = AllocBuffer();
			if (status) return status;

			status = Transfer();
			if (status) return status;

			StopTransfer();

			status = FreeBuffer();
			if (status) return status;

			return status;
		}

		status AllocBuffer()
		{
			status	status = EARTH::PT::STATUS_OK;

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					uint32	index = i*2 + j;
					if (mBuffer[index] == NULL) {
						mBuffer[index] = new Buffer(mDevice);
						status = mBuffer[index]->Alloc(1024*1024, 1, false);
						if (status) return status;
					}
				}
			}

			return status;
		}

		status FreeBuffer()
		{
			status	status = EARTH::PT::STATUS_OK;

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					uint32	index = i*2 + j;
					delete_(mBuffer[index]);
				}
			}

			return status;
		}

		status Transfer()
		{
			status	status;

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					uint32	index = i*2 + j;
					status = mDevice->SetTransferPageDescriptorAddress(isdb, j, mBuffer[index]->PageDescriptorAddress());
					if (U::Error(L"SetTransferPageDescriptorAddress()", status)) return status;
				}
			}

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					uint16	lfsr = TransferLFSR(isdb, j);
					status = mDevice->SetTransferTestMode(isdb, j, true, lfsr);
					if (U::Error(L"SetTransferTestMode()", status)) return status;

					uint32	index = i*2 + j;

					void	*ptr = mBuffer[index]->Ptr(0);
					::memset(ptr, 0, 1024*1024);

					status = mBuffer[index]->SyncCpu(0);
					if (U::Error(L"SyncCPU()", status)) return false;

					status = mDevice->SetTransferEnabled(isdb, j, true);
					if (U::Error(L"SetTransferEnabled()", status)) return status;
				}
			}

			PT::Device::ISDB	stopIsdb  = static_cast<PT::Device::ISDB>(rand() % 2);
			uint32				stopIndex = rand() % 2;

			Sleep(10 + rand() % 40);
			status = mDevice->SetTransferEnabled(stopIsdb, stopIndex, false);
			if (U::Error(L"SetTransferEnabled()", status)) return status;

			status = mDevice->SetTransferTestMode(stopIsdb, stopIndex);
			if (U::Error(L"SetTransferTestMode()", status)) return status;

			//::wprintf(L"~Ώ: %d\n", stopIsdb*2 + stopIndex);

			// ]I܂ő҂
			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					bool	done = false;
					for (uint32 k=0; k<2000; k++) {
						PT::Device::TransferInfo	info;
						status = mDevice->GetTransferInfo(isdb, j, &info);
						if (U::Error(L"GetTransferInfo()", status)) return status;

						if (info.InternalFIFO_A_Overflow ) { done = true; ::wprintf(L"InternalFIFO_A_Overflow ܂B\n"); }
						if (info.InternalFIFO_A_Underflow) { done = true; ::wprintf(L"InternalFIFO_A_Underflow ܂B\n"); }
						if (info.ExternalFIFO_Overflow   ) { done = true; ::wprintf(L"ExternalFIFO_Overflow ܂B\n"); }
						if (info.InternalFIFO_B_Overflow ) { done = true; ::wprintf(L"InternalFIFO_B_Overflow ܂B\n"); }
						if (info.InternalFIFO_B_Underflow) { done = true; ::wprintf(L"InternalFIFO_B_Underflow ܂B\n"); }
						if (info.Busy == false) { done = true; }

						if (done) break;

						OS::Thread::Sleep(1);
					}

					if (done == false) {
						::wprintf(L"]I܂łB\n");
						return 1;
					}
				}
			}

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					uint32	index = i*2 + j;
					if (index != stopIsdb*2 + stopIndex) {
						status = mBuffer[index]->SyncIo(0);
						if (U::Error(L"SyncIo()", status)) return false;

						const uint16	*ptr = static_cast<const uint16 *>(mBuffer[index]->Ptr(0));
						uint16	lfsr = TransferLFSR(isdb, j);
						for (uint32 k=0; k<1024*1024/2; k++) {
							uint16	compareData = lfsr;
							if (ptr[k] != compareData) {
								::wprintf(L"]f[^Ɍ肪܂B\n");
								return 1;
							}
							lfsr = (lfsr >> 1) ^ (-(lfsr & 1) & 0xb400);
						}
					}
				}
			}

			return status;
		}

		void StopTransfer()
		{
			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					status	status;
					status = mDevice->SetTransferEnabled(isdb, j, false);
					status = mDevice->SetTransferTestMode(isdb, j);
				}
			}
		}

		uint16 TransferLFSR(PT::Device::ISDB isdb, uint32 index) const
		{
			return static_cast<uint16>((1 + 2*isdb + index)*12345);
		}
	};
}
}

#endif
