#ifndef _EX_Main_H
#define _EX_Main_H

#include "Prefix.h"
#include "EX_Bus.h"
#include "OS_Library.h"

namespace EARTH {
namespace EX {
	class Main {
	public:
		Main()
		{
			mLibrary = NULL;

			::timeBeginPeriod(1);
		}

		~Main()
		{
			delete_(mLibrary);

			::timeEndPeriod(1);
		}

		void Run()
		{
			wchar_t		*name =
			#if PUBLIC_LEVEL != 2
				L"Example"
			#else
				L"Update"
			#endif
			;

			::wprintf(L"%s.exe for PT3 o[W 0.96 2012/07/11\n", name);

			_ASSERT(mLibrary == NULL);
			mLibrary = new OS::Library();

			PT::Bus::NewBusFunction		function = mLibrary->Function();
			if (function == NULL) {
				::wprintf(L"%s ǂݍ߂܂łB\n", mLibrary->Path());
				return;
			}

			EX::Bus		*bus = new Bus();
			bus->Run(function);
			delete_(bus);
		}

	protected:
		OS::Library		*mLibrary;
	};
}
}

#endif
