#ifndef _EX_Test_H
#define _EX_Test_H

#include "Prefix.h"
#include "EARTH_PT3.h"
#include "EX_Stream.h"
#include "EX_Utility.h"
#include "OS_Thread.h"

namespace EARTH {
namespace EX {
	class Test {
	public:
		Test(PT::Device *device) : mDevice(device)
		{
			for (uint32 i=0; i<sizeof(mBuffer)/sizeof(*mBuffer); i++) {
				mBuffer[i] = NULL;
			}
		}

		~Test()
		{
			for (uint32 i=0; i<sizeof(mBuffer)/sizeof(*mBuffer); i++) {
				delete_(mBuffer[i]);
			}
		}

		bool CheckHardware()
		{
			bool	b;

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					status	status;
					bool	enabled;
					status = mDevice->GetTransferEnabled(isdb, j, &enabled);
					if (U::Error(L"GetTransferEnabled()", status)) return false;
					if (enabled) {
						::wprintf(L"SĂ DMA ~ԂłȂ߁Asł܂B\n");
						return false;
					}
				}
			}

			b = TestHardware();
			mDevice->SetRamPinsMode(EARTH::PT::Device::RAM_PINS_MODE_NORMAL);
			if (b) {
				::wprintf(L"\n");
				::wprintf(L"nj  Ɋ܂B\n");
				::wprintf(L"\n");
			} else {
				::wprintf(L"\n");
				::wprintf(L" mf  G[܂B \n");
				::wprintf(L"\n");
			}

			return b;
		}

	protected:
		PT::Device *const	mDevice;
		Buffer				*mBuffer[2*2];

		bool TestHardware()
		{
			bool	b;

			::wprintf(L"EŒlǂ`FbNĂ܂B\n");
			b = ConstantInfo();
			if (b == false) return b;

			::wprintf(L"ETS s̃`FbNĂ܂B\n");
			for (uint32 i=0; i<3; i++) {
				mDevice->SetRamPinsMode(static_cast<EARTH::PT::Device::RamPinsMode>(2-i));
				b = TsPins();
				if (b == false) return b;
				::wprintf(L"  RAM s[h %d ͖肠܂łB\n", 2-i);
			}

			TsPinsNormal();
			::Sleep(10);

			::wprintf(L"ETS oCg`FbNĂ܂B\n");
			b = TsSyncByte();
			if (b == false) return b;

			::wprintf(L"E`[i[ PLL bN邩`FbNĂ܂B\n");
			b = TunerPLL();
			if (b == false) return b;

			::wprintf(L"EeXgf[^]ăf[^`FbNĂ܂B\n");
			b = Transfer(false);
			if (b) {
				b = Transfer(true);
			}
			TransferCleanUp();
			if (b == false) return b;

			return b;
		}

		bool ConstantInfo()
		{
			PT::Device::ConstantInfo	info;
			status	status = mDevice->GetConstantInfo(&info);
			if (status) {
				::wprintf(L"G[ GetConstantInfo()\n");
				return false;
			}

			if (info.PTn != 0x03) {
				::wprintf(L"Œl1Ɍ肪܂B\n");
				return false;
			}

			if (info.Version_RegisterMap != 0x01) {
				::wprintf(L"Œl2Ɍ肪܂B\n");
				return false;
			}

			if (info.Version_FPGA != 0x04) {
				::wprintf(L"Œl3Ɍ肪܂B\n");
				return false;
			}

			if (info.CanTransportTS != true) {
				::wprintf(L"Œl4Ɍ肪܂B\n");
				return false;
			}

			return true;
		}

		bool TsPins()
		{
			for (uint32 i=0; i<256; i++) {
				uint32	level;
				bool	b = TsPins(i, &level);
				if (b == false) return false;

				if (i != level) {
					::wprintf(L"%02x %02x\n", i, level);
					return false;
				}
			}

			return true;
		}

		bool TsPins(uint32 mode, uint32 *level_)
		{
//			mDevice->GetTsPinsLevel(PT::Device::ISDB_S, 0, &level);

			PT::Device::TsPinsMode	table[2][2];
			for (uint32 i=0; i<2; i++) {
				for (uint32 j=0; j<2; j++) {
					PT::Device::TsPinsMode	*ptr = &table[i][j];
					uint32	bit = 2*(2*i+j);
					ptr->byte  = (mode & (1<<(bit+0))) ? PT::Device::TS_PIN_MODE_HIGH : PT::Device::TS_PIN_MODE_LOW;
					ptr->valid = (mode & (1<<(bit+1))) ? PT::Device::TS_PIN_MODE_HIGH : PT::Device::TS_PIN_MODE_LOW;
				}
			}

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					PT::Device::TsPinsMode	*ptr = &table[i][j];

					// clock gO邩`FbN
					bool	clock[4];
					for (uint32 k=0; k<4; k++) {
						for (uint32 l=0; l<2; l++) {
							ptr->clock_data = (l == 0) ? PT::Device::TS_PIN_MODE_HIGH : PT::Device::TS_PIN_MODE_LOW;
							mDevice->SetTsPinsMode(isdb, j, ptr);

							if (l == 0) {
								PT::Device::TsPinsLevel		pinsLevel;
								mDevice->GetTsPinsLevel(isdb, j, &pinsLevel);
								clock[k] = pinsLevel.clock;
							}
						}
					}
					if ((clock[0] == clock[1]) || (clock[1] == clock[2]) || (clock[2] == clock[3])) {
						::wprintf(L"TS NbNɈُ킪܂B\n");
						return false;
					}
				}
			}

			uint32	level = 0;
			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					PT::Device::TsPinsLevel		pinsLevel;
					mDevice->GetTsPinsLevel(isdb, j, &pinsLevel);

					uint32	bit = 2*(2*i+j);

					level |= (pinsLevel.byte  ? 1 : 0) << (bit+0);
					level |= (pinsLevel.valid ? 1 : 0) << (bit+1);
				}
			}
			*level_ = level;

			return true;
		}

		void TsPinsNormal()
		{
			PT::Device::TsPinsMode	mode;
			mode.clock_data = PT::Device::TS_PIN_MODE_NORMAL;
			mode.byte       = PT::Device::TS_PIN_MODE_NORMAL;
			mode.valid      = PT::Device::TS_PIN_MODE_NORMAL;

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					mDevice->SetTsPinsMode(isdb, j, &mode);
				}
			}
		}

		bool TsSyncByte()
		{
			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					uint8	syncByte;
					mDevice->GetTsSyncByte(isdb, j, &syncByte);
					if (syncByte != 0x47) {
						::wprintf(L"oCgɈُ킪܂B\n");
						return false;
					}
				}
			}

			return true;
		}

		bool TunerPLL()
		{
			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					status	status = mDevice->SetFrequency(isdb, j, 0);
					if (U::Error(L"Device::SetFrequency()", status)) return false;
				}
			}

			return true;
		}

		bool Transfer(bool not)
		{
			status	status;

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					uint32	index = i*2 + j;
					if (mBuffer[index] == NULL) {
						mBuffer[index] = new Buffer(mDevice);
						mBuffer[index]->Alloc(1024*1024, 1, false);
						status = mDevice->SetTransferPageDescriptorAddress(isdb, j, mBuffer[index]->PageDescriptorAddress());
						if (U::Error(L"SetTransferPageDescriptorAddress()", status)) return false;
					}
				}
			}

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					uint32	index = i*2 + j;

					void	*ptr = mBuffer[index]->Ptr(0);
					::memset(ptr, 0, 1024*1024);

					status = mBuffer[index]->SyncCpu(0);
					if (U::Error(L"SyncCPU()", status)) return false;

					uint16	lfsr = TransferLFSR(isdb, j);
					status = mDevice->SetTransferTestMode(isdb, j, true, lfsr, not);
					if (U::Error(L"SetTransferTestMode()", status)) return false;

					status = mDevice->SetTransferEnabled(isdb, j, true);
					if (U::Error(L"SetTransferEnabled()", status)) return false;
				}
			}

			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					bool	done = false;
					for (uint32 k=0; k<2000; k++) {
						PT::Device::TransferInfo	info;
						status = mDevice->GetTransferInfo(isdb, j, &info);
						if (U::Error(L"GetTransferInfo()", status)) return false;
						if (info.Busy == false) {
							done = true;
							break;
						}
						OS::Thread::Sleep(1);
					}

					if (done == false) {
						::wprintf(L"]I܂łB\n");
						return false;
					}
					
					uint32	index = i*2 + j;

					status = mBuffer[index]->SyncIo(0);
					if (U::Error(L"SyncIo()", status)) return false;

					const uint16	*ptr = static_cast<const uint16 *>(mBuffer[index]->Ptr(0));
					uint16	lfsr = TransferLFSR(isdb, j);
					for (uint32 k=0; k<1024*1024/2; k++) {
						uint16	compareData = not ? ~lfsr : lfsr;
						if (ptr[k] != compareData) {
							::wprintf(L"]f[^Ɍ肪܂B\n");
							return false;
						}
						lfsr = (lfsr >> 1) ^ (-(lfsr & 1) & 0xb400);
					}
				}
			}

			return true;
		}

		void TransferCleanUp()
		{
			for (uint32 i=0; i<PT::Device::ISDB_COUNT; i++) {
				PT::Device::ISDB	isdb = static_cast<PT::Device::ISDB>(i);
				for (uint32 j=0; j<2; j++) {
					status	status;
					status = mDevice->SetTransferEnabled(isdb, j, false);
					status = mDevice->SetTransferTestMode(isdb, j);

					uint32	index = i*2 + j;
					if (mBuffer[index]) {
						delete_(mBuffer[index]);
					}
				}
			}
		}

		uint16 TransferLFSR(PT::Device::ISDB isdb, uint32 index) const
		{
			return static_cast<uint16>((1 + 2*isdb + index)*12345);
		}
	};
}
}

#endif
